#! /bin/sh

if [ $# -le 7 ]
then
    echo "Usage:" 2>&1
    echo "plot.sh -i \\" 2>&1
    echo "        -o nom_base_fichier_sortie \\" 2>&1
    echo "        -T titre \\" 2>&1
    echo "        -x tiquette_axe_x \\" 2>&1
    echo "        -t numro_test \\" 2>&1
    echo "        -L x,y (position du titre)\\" 2>&1
    echo "        -- option_test valeur..." 2>&1  
    exit 1
fi

Interactive=""
Title=
OutputFile=out_$$
XTitle=
LabelPos="200,70"
SimulOpt=
TestNum=5

for arg in $*
do
    case $1 in
    -i) Interactive="-"; shift;;
    -T) Title="$2"; shift 2;;
    -o) Out="$2"; shift 2;;
    -x) XTitle="$2"; shift 2;;
    -t) TestNum="$2"; shift 2;;
    -l) LabelPos="$2"; shift 2;; 
    --) shift; break;;
    esac
done
SimulOpt="$1"; shift

echo Titre : $Title
echo Fichier : $Out
echo Axe des X : $XTitle
echo Numro de test : $TestNum
echo Option de simulation : $SimulOpt
echo Valeurs : $*

rm -f $Out.gp $Out 

for n in $*
do
    echo -n $n
    tst_Cache_NUR.exe -t $TestNum $SimulOpt $n -S | \
                                        awk '$1 ~ /hits/ {printf " %.2f ", $2}' 
    tst_Cache_LRU.exe -t $TestNum $SimulOpt $n -S | \
                                        awk '$1 ~ /hits/ {printf "%.2f ", $2}' 
    tst_Cache_FIFO.exe -t $TestNum $SimulOpt $n -S | \
                                        awk '$1 ~ /hits/ {printf "%.2f ", $2}' 
    tst_Cache_RAND.exe -t $TestNum $SimulOpt $n -S | \
                                        awk '$1 ~ /hits/ {printf "%.2f\n", $2}' 

done > $Out

ed - << EOF
a
set data style linespoints
set xlabel "$XTitle"
set ylabel "Hit rate (%)" font "Helvetica-Oblique"
set label "$Title (test $TestNum)" font "Helvetica-Bold,18" 
set encoding iso_8859_1
set terminal postscript eps color
set output "$Out.eps"
plot "$Out" using 1:2 t "NUR", "$Out" using 1:3 t "LRU", "$Out" using 1:4 t "FIFO", "$Out" using 1:5 t "RAND"
.
w $Out.gp
q
EOF

if [ -n "$Interactive" ]
then
    ed - $Out.gp << EOF
a
set terminal x11
plot "$Out" using 1:2 t "NUR", "$Out" using 1:3 t "LRU", "$Out" using 1:4 t "FIFO", "$Out" using 1:5 t "RAND"
.
w
q
EOF
fi

gnuplot $Out.gp $Interactive

exit 0
